﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Data.Common;

using ActiveDatabaseSoftware.ActiveQueryBuilder;

namespace SQLQueryBuilder
{
    public partial class SQLQueryBuilder : Form
    {
        public SQLQueryBuilder()
        {
            InitializeComponent();
        }

        private string _defaultConString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\NWIND.MDB;Persist Security Info=False";
        private void SQLQueryBuilder_Load(object sender, EventArgs e)
        {
            OleDbConnection connection = new OleDbConnection();

            // we will use the mdb in c drive to demonstrate this
            // connection.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\NWIND.MDB;Persist Security Info=False";
            connection.ConnectionString = this._connectionString;

            OLEDBMetadataProvider metadataProvider = new OLEDBMetadataProvider();
            metadataProvider.Connection = connection;

            UniversalSyntaxProvider syntaxProvider = new UniversalSyntaxProvider();          

            this.queryBuilder1.MetadataProvider = metadataProvider;
            this.queryBuilder1.SyntaxProvider = syntaxProvider;
           
            this.plainTextSQLBuilder1.QueryBuilder = this.queryBuilder1;

            queryBuilder1.RefreshMetadata();
        }
        

        private void queryBuilder1_SQLUpdated(object sender, EventArgs e)
        {
            this._sqlEditor.Text = this.plainTextSQLBuilder1.SQL;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            queryBuilder1.RefreshMetadata();
        }

        private void plainTextSQLBuilder1_SQLUpdated(object sender, EventArgs e)
        {
            _sqlEditor.Text = plainTextSQLBuilder1.SQL;

        }

        private void _sqlEditor_Leave(object sender, EventArgs e)
        {
            try
            {
                queryBuilder1.SQL = _sqlEditor.Text;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Parsing error");
            }
        }

        private string _connectionString;

        /// <summary>
        /// Gets or Sets the ConnectioStering property of the QueryBiuilder
        /// 
        /// </summary>
        public string ConnectionString
        {
            get
            {
                return this._connectionString;
            }
            set
            {
                if (null == value || string.Empty == value)
                    value = _defaultConString;

                this._connectionString = value;
            }
        }


        /// <summary>
        /// Return the SQL Query to be assigned to the report.
        /// </summary>
        private string _reportQuery = string.Empty;
        public string ReportQuery
        {
            get
            {
                return this._reportQuery;
            }
        }

        private void _btnOK_Click(object sender, EventArgs e)
        {
            // set the final result here
            this._reportQuery = this._sqlEditor.Text;
        }

    }
}
